nxt.blockchain

## Interface Blockchain

- All Known Implementing Classes:
    BlockchainImpl

      public interface Blockchain

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `DbIterator<? extends Block>` | `getAllBlocks()`
    `Block` | `getBlock(long blockId)`
    `Block` | `getBlock(long blockId, boolean loadTransactions)`
    `Block` | `getBlockAtHeight(int height)`
    `int` | `getBlockCount(long accountId)`
    `long` | `getBlockIdAtHeight(int height)`
    `java.util.List<java.lang.Long>` | `getBlockIdsAfter(long blockId, int limit)`
    `DbIterator<? extends Block>` | `getBlocks(java.sql.Connection con, java.sql.PreparedStatement pstmt)`
    `DbIterator<? extends Block>` | `getBlocks(int from, int to)`
    `DbIterator<? extends Block>` | `getBlocks(long accountId, int timestamp)`
    `DbIterator<? extends Block>` | `getBlocks(long accountId, int timestamp, int from, int to)`
    `java.util.List<? extends Block>` | `getBlocksAfter(long blockId, int limit)`
    `java.util.List<? extends Block>` | `getBlocksAfter(long blockId, java.util.List<java.lang.Long> blockList)`
    `Block` | `getECBlock(int timestamp)`
    `DbIterator<? extends Transaction>` | `getExecutedTransactions(Chain chain, long senderId, long recipientId, byte type, byte subtype, int height, int numberOfConfirmations, int from, int to)`
    `java.util.List<? extends Transaction>` | `getExpectedTransactions(Filter<Transaction> filter)`
    `FxtTransaction` | `getFxtTransaction(long transactionId)`
    `int` | `getHeight()`
    `Block` | `getLastBlock()`
    `Block` | `getLastBlock(int timestamp)`
    `int` | `getLastBlockTimestamp()`
    `DbIterator<? extends ChildTransaction>` | `getReferencingTransactions(ChildChain chain, byte[] referencedTransactionFullHash, int from, int to)`
    `Transaction` | `getTransaction(Chain chain, byte[] fullHash)`
    `int` | `getTransactionCount(Chain chain)`
    `DbIterator<? extends ChildTransaction>` | `getTransactions(ChildChain childChain, java.sql.Connection con, java.sql.PreparedStatement pstmt)`
    `DbIterator<? extends ChildTransaction>` | `getTransactions(ChildChain chain, long accountId, byte type, byte subtype, int blockTimestamp, boolean includeExpiredPrunable)`
    `DbIterator<? extends ChildTransaction>` | `getTransactions(ChildChain chain, long accountId, int numberOfConfirmations, byte type, byte subtype, int blockTimestamp, boolean withMessage, boolean phasedOnly, boolean nonPhasedOnly, int from, int to, boolean includeExpiredPrunable, boolean executedOnly)`
    `DbIterator<? extends FxtTransaction>` | `getTransactions(FxtChain chain, java.sql.Connection con, java.sql.PreparedStatement pstmt)`
    `DbIterator<? extends FxtTransaction>` | `getTransactions(FxtChain chain, long accountId, int numberOfConfirmations, byte type, byte subtype, int blockTimestamp, int from, int to)`
    `boolean` | `hasBlock(long blockId)`
    `boolean` | `hasFxtTransaction(long transactionId)`
    `boolean` | `hasTransaction(Chain chain, byte[] fullHash)`
    `void` | `readLock()`
    `void` | `readUnlock()`
    `void` | `updateLock()`
    `void` | `updateUnlock()`

- - ### Method Detail

    - #### readLock

          void readLock()

    - #### readUnlock

          void readUnlock()

    - #### updateLock

          void updateLock()

    - #### updateUnlock

          void updateUnlock()

    - #### getLastBlock

          Block getLastBlock()

    - #### getLastBlock

          Block getLastBlock(int timestamp)

    - #### getHeight

          int getHeight()

    - #### getLastBlockTimestamp

          int getLastBlockTimestamp()

    - #### getBlock

          Block getBlock(long blockId)

    - #### getBlock

          Block getBlock(long blockId,
                         boolean loadTransactions)

    - #### getBlockAtHeight

          Block getBlockAtHeight(int height)

    - #### hasBlock

          boolean hasBlock(long blockId)

    - #### getAllBlocks

          DbIterator<? extends Block> getAllBlocks()

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(int from,
                                                int to)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(long accountId,
                                                int timestamp)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(long accountId,
                                                int timestamp,
                                                int from,
                                                int to)

    - #### getBlockCount

          int getBlockCount(long accountId)

    - #### getBlocks

          DbIterator<? extends Block> getBlocks(java.sql.Connection con,
                                                java.sql.PreparedStatement pstmt)

    - #### getBlockIdsAfter

          java.util.List<java.lang.Long> getBlockIdsAfter(long blockId,
                                                          int limit)

    - #### getBlocksAfter

          java.util.List<? extends Block> getBlocksAfter(long blockId,
                                                         int limit)

    - #### getBlocksAfter

          java.util.List<? extends Block> getBlocksAfter(long blockId,
                                                         java.util.List<java.lang.Long> blockList)

    - #### getBlockIdAtHeight

          long getBlockIdAtHeight(int height)

    - #### getECBlock

          Block getECBlock(int timestamp)

    - #### getTransaction

          Transaction getTransaction(Chain chain,
                                     byte[] fullHash)

    - #### hasTransaction

          boolean hasTransaction(Chain chain,
                                 byte[] fullHash)

    - #### getFxtTransaction

          FxtTransaction getFxtTransaction(long transactionId)

    - #### hasFxtTransaction

          boolean hasFxtTransaction(long transactionId)

    - #### getTransactionCount

          int getTransactionCount(Chain chain)

    - #### getTransactions

          DbIterator<? extends ChildTransaction> getTransactions(ChildChain chain,
                                                                 long accountId,
                                                                 byte type,
                                                                 byte subtype,
                                                                 int blockTimestamp,
                                                                 boolean includeExpiredPrunable)

    - #### getTransactions

          DbIterator<? extends ChildTransaction> getTransactions(ChildChain chain,
                                                                 long accountId,
                                                                 int numberOfConfirmations,
                                                                 byte type,
                                                                 byte subtype,
                                                                 int blockTimestamp,
                                                                 boolean withMessage,
                                                                 boolean phasedOnly,
                                                                 boolean nonPhasedOnly,
                                                                 int from,
                                                                 int to,
                                                                 boolean includeExpiredPrunable,
                                                                 boolean executedOnly)

    - #### getTransactions

          DbIterator<? extends FxtTransaction> getTransactions(FxtChain chain,
                                                               long accountId,
                                                               int numberOfConfirmations,
                                                               byte type,
                                                               byte subtype,
                                                               int blockTimestamp,
                                                               int from,
                                                               int to)

    - #### getTransactions

          DbIterator<? extends FxtTransaction> getTransactions(FxtChain chain,
                                                               java.sql.Connection con,
                                                               java.sql.PreparedStatement pstmt)

    - #### getTransactions

          DbIterator<? extends ChildTransaction> getTransactions(ChildChain childChain,
                                                                 java.sql.Connection con,
                                                                 java.sql.PreparedStatement pstmt)

    - #### getExpectedTransactions

          java.util.List<? extends Transaction> getExpectedTransactions(Filter<Transaction> filter)

    - #### getReferencingTransactions

          DbIterator<? extends ChildTransaction> getReferencingTransactions(ChildChain chain,
                                                                            byte[] referencedTransactionFullHash,
                                                                            int from,
                                                                            int to)

    - #### getExecutedTransactions

          DbIterator<? extends Transaction> getExecutedTransactions(Chain chain,
                                                                    long senderId,
                                                                    long recipientId,
                                                                    byte type,
                                                                    byte subtype,
                                                                    int height,
                                                                    int numberOfConfirmations,
                                                                    int from,
                                                                    int to)